EVAL <5 'mclass' (Method variables) 6>
EVAL <5 ('Meta' + Number name) (Number class) 1>
EVAL <5 (<4 String>) (String class) 4>
EVAL <5 (List new asArray with: 'symbols') (String class) 5>
META String
intern: aValue
	" compiler hook for interning values "
	^ aValue
!
METHOD Parser
parse: c	| encoder selector re crlf |
	" note -- must call text:instanceVars: first "
	crlf <- (Char new: 10) asString + (Char new: 13) asString.
	errBlock <- [ ^ nil ].
	self nextLex.
	encoder <- Encoder new.
	encoder name: (selector <- String intern: self readMethodName).
	re <- ''. c methods do: [:each | each name = selector ifTrue: [re <- 're']].
	<3 (re + 'compiling ' + c name + ' ' + selector + crlf)>.
	self readMethodVariables.
	self readBody compile: encoder block: false.
	^ encoder method: maxTemps class: c text: text
!
METHOD Encoder
genCode: byte
	(256 <= byte)
		ifTrue: [self error: 'cannot generate ' + byte printString].
	byteCodes add: byte.
	^ byteCodes size
!
METHOD Encoder
genHigh: high low: low
	(256 <= low or: [256 <= high])
		ifTrue: [self error: 'cannot generate ' + high printString + ' ' + low printString].
	(16 <= low)
		ifTrue: [ self genHigh: 0 low: high. self genCode: low ]
		ifFalse: [ self genCode: high * 16 + low ]
!
METHOD Char
= arg
	^ arg = value
!
METHOD Parser
lexAlphabetic | cc start |
	start <- index.
	[ (cc <- self nextChar) isAlphabetic
		or: [start < index and: [cc isAlphanumeric ] ] ]
			whileTrue: [ nil ].
		" add any trailing colons "
	cc = $: ifTrue: [ self nextChar ].
	token <- text from: start to: index - 1
!
METHOD MessageNode
receiver: r name: n arguments: a
	receiver <- r.
	name <- String intern: n.
	arguments <- a
!
METHOD Object
isNumber
	^ false
!
METHOD Number
isNumber
	^ true
!
METHOD Float
= arg
	(<1 (<2 arg>) Char>) ifTrue: [^ arg value = self].
	arg isNumber ifFalse: [^ false].
	^ arg asFloat equalToFloat: self
!
METHOD LargeNegative
= arg
	(<1 (<2 arg>) Char>) ifTrue: [^ arg value = self].
	arg isNumber ifFalse: [^ false].
	^ self negated = arg negated
!
METHOD LargePositive
= arg
	(<1 (<2 arg>) Char>) ifTrue: [^ arg value = self].
	arg isNumber ifFalse: [^ false].
	^ 0 = (arg compareToLP: self)
!
METHOD SmallInt
= arg
	(<1 (<2 arg>) Char>) ifTrue: [^ arg value = self].
	arg isNumber ifFalse: [^ false].
	^ arg equalToSmallInt: self
!
METHOD Array
indexOf: element ifAbsent: exceptionBlock
	" #(1 b $c) indexOf: $c ifAbsent: [ ^ false ] "
	| j sentinel |
	self class == Array ifFalse: [ ^ super indexOf: element ifAbsent: exceptionBlock ].
	j <- 1.
	sentinel <- (<4 self>) "self size".
	[ j <= sentinel ] whileTrue: [ (element = (<30 self j>)) ifTrue: [ ^ j ].
	 j <- j + 1].
	^ exceptionBlock value
!
METHOD List
indexOf: element ifAbsent: exceptionBlock
	"(List new addAll: #(1 $b 'c')) indexOf: 'c' ifAbsent: [ ^ false ]"
	| j sentinel |
	j <- 1.
	sentinel <- current "self size".
	[ j <= sentinel ] whileTrue: [ (element = (<30 values j>)) ifTrue: [ ^ j ].
	 j <- j + 1].
	^ exceptionBlock value
!
METHOD Parser
nameNode: name
	" make a new name node "
	| pos |
	name = 'super'
		ifTrue: [ ^ ArgumentNode new position: 0 ].
	pos <- tempNames indexOf: name ifAbsent: [ nil ].
	(<1 pos nil>) ifFalse: [ ^ TemporaryNode new position: pos ].
	pos <- argNames indexOf: name ifAbsent: [ nil ].
	(<1 pos nil>) ifFalse: [ ^ ArgumentNode new position: pos ].
	pos <- instNames indexOf: name ifAbsent: [ nil ].
	(<1 pos nil>) ifFalse: [ ^ InstNode new position: pos ].
	^ LiteralNode new value: (self findName: name)
!
METHOD Encoder
genLiteral: aValue
	| lit j sentinel |
	(aValue isNumber or: [<1 (<2 aValue>) String>])
		ifTrue: [lit <- String intern: aValue] ifFalse: [lit <- aValue].
	j <- 1.
	sentinel <- (<4 literals>).
	[j < sentinel] whileTrue: [(lit = (<30 literals j>)) ifTrue: [^ j - 1].
		j <- j + 1].
	literals <- literals with: lit. ^ literals size - 1
!
META Class
fileAllMethodsTo: aFile
	| text white newline |
	white <- $ .
	newline <- Char newline asString.
	classes do: [:aClass |
	 aClass methods do: [:m |
		text <- m text.
		[(text at: text size) <= white] whileTrue: [text <- text from: 1 to: text size -1].
		super in: m at: 7 put: text.
		aFile write: 'METHOD ' + aClass name + ' ' + m name + newline +
			text + newline + '!' + newline ].
	 aClass class methods do: [:m |
		text <- m text.
		[(text at: text size) <= white] whileTrue: [text <- text from: 1 to: text size -1].
		super in: m at: 7 put: text.
		aFile write: 'META ' + aClass name + ' ' + m name + newline +
			text + newline + '!' + newline ] ].
	^ 'File out successful'
!
METHOD Object
isBehavior
	^ false
!
META Class
at: aName ifAbsent: noValue
	classes do: [:x |
		aName = x name ifTrue: [ ^ x ].
		aName = (<2 x>) name ifTrue: [ ^ (<2 x>) ]
	].
	^ noValue value
!
METHOD Class
isBehavior
	^ true
!
METHOD Class
name: n parent: p variables: v
	" private method used for initialization "
	name <- n.
	parentClass <- p.
	variables <- v.
	methods isNil ifTrue: [methods <- Array new: 0].
	size <- v size + (p isNil ifTrue: [0] ifFalse: [p size])
!
METHOD String
replace: oldChar by: newChar
	| oldValue newValue j sentinel |
	" 'abcd' replace: $c by: $x "
	oldValue <- oldChar value.
	newValue <- newChar value.
	j <- 1.
	sentinel <- (<4 self>) "self size".
	[ j <= sentinel ] whileTrue: [ (<1 ((<21 self j>) - oldValue) 0>)
		ifTrue: [<22 newValue self j>].
	 j <- j + 1]
!
META Array
new: newSize
	^ <7 self newSize>
!
META ByteArray
new: newSize
	^ <20 ByteArray newSize>
!
META Class
at: aName ifAbsent: noValue
	classes do: [:x | aName = x name ifTrue: [ ^ x ] ].
	^ noValue value
!
META File
openRead: aName
	^ <42 self (aName printString)>
!
META File
openWrite: aName
	^ <41 self (aName printString)>
!
META File
saveImage: aName
	<29 (aName printString)>.
	^ 'Image saved in file ' + aName
!
META String
new: newSize
	^ <20 String newSize>
!
METHOD String
indexOf: element ifAbsent: exceptionBlock
	" '1 b $c' indexOf: $b ifAbsent: [ ^ false ] "
	| j sentinel aValue |
	self class == String ifFalse: [ ^ super indexOf: element ifAbsent: exceptionBlock ].
	j <- 1.
	sentinel <- (<4 self>) "self size".
	aValue <- element value.
	[ j <= sentinel ] whileTrue: [ (aValue = (<21 self j>)) ifTrue: [ ^ j ].
	 j <- j + 1].
	^ exceptionBlock value
!
METHOD List
remove: element
	self remove: element ifAbsent: [ nil ]
!
METHOD File
fileIn  | line cls blank |
	blank <- Char new: (' ' at: 1).
	[(line <- self readLine) notNil] whileTrue: 
		[ ((line from: 1 to: (4 min: line size)) = 'EVAL')
			ifTrue: [ (line from: 6 to: line size) doIt ].
		  ((line from: 1 to: (6 min: line size)) = 'METHOD')
			ifTrue: [ line <- line from: 8 to: line size.
				line <- line from: 1 to: (line indexOf: blank ifAbsent: [1 + line size]) - 1.
				cls <- Class at: line ifAbsent:
					[ self error: 'unknown name in fileIn ' + line].
				cls compileMethod: (self readTo: '!') ].
		  ((line from: 1 to: (4 min: line size)) = 'META')
			ifTrue: [ line <- line from: 6 to: line size.
				line <- line from: 1 to: (line indexOf: blank ifAbsent: [1 + line size]) - 1.
				cls <- Class at: line ifAbsent:
					[ self error: 'unknown name in fileIn ' + line].
				cls class compileMethod: (self readTo: '!') ] ].
	^ 'File In Successful'
!
METHOD Undefined
version
	^ 'image version 0.9'
!
